<template lang="pug">
  div
    .form-horizontal
      .divider.text-center(data-content="Federation")
      .form-group
        .col-3.col-sm-12
          label {{ $tc('follow', 1) }} {{ $tc('instance', 2) | lowercase }}
        apollo-mutation.col-9.col-sm-12(
          :mutation="$options.createFollowGql"
          :variables=`{
            domain,
            scan: autoapprove
          }`
          :refetchQueries="(mutationResult) => [{ query: $options.listInstanceFollowsGql }]"
          @error="(errorObject) => $toast.error(`Error trying to follow instance`, {icon: 'warning'})"
        )
          template(v-slot="{ mutate, loading, error }")
            z-input.text-left.mb-5(v-model="domain" type="text" placeholder="instance URI (i.e. http://example.org)")
            dropdown-button.text-right(caret=true variant="primary" :onConfirm="() => { mutate() && reset()}")
              | {{ action | capitalize }} {{ $tc('instance', 1) | lowercase }}
              template(slot="container")
                li.menu-item
                  a.menu-item(:class="{ active: action == 'follow' }" @click="() => action = 'follow'")
                    small {{ $tc('follow', 1) }}
              //-
                li.menu-item
                  a.menu-item(:class="{ active: action == 'delete' }" @click="() => action = 'delete'")
                    small {{ $t('delete') }}
                li.menu-item
                  a.menu-item(:class="{ active: action == 'block' }" @click="() => action = 'block'")
                    small {{ $tc('block', 1) }}
      fieldset(:disabled="true")
        .form-group
          .col-3.clom-sm-12
            label {{ $t('federation') }}
          .col-9.col-sm-12
            z-switch(v-model="autoapprove")
              .label-text Allow other instances to follow yours
              .label-hint Other instances will display your public local corpora and their discussions, giving them more reach.
            z-switch
              .label-text Manually review new instances following yours
              .label-hint You will have more control over who can display your public local corpora, at the cost of delayed reach and increased review work.
      .form-group
        .col-3.col-sm-12
        .col-9.col-sm-12
          about-follows(withAdmin)
</template>

<script>
import AboutFollows from '~/components/AboutFollows'
import DropdownButton from '~/components/DropdownButton'

import createFollowGql from '~/apollo/mutations/createFollow'
import listInstanceFollowsGql from '~/apollo/queries/listInstanceFollows'

export default {
  createFollowGql,
  listInstanceFollowsGql,

  components: {
    AboutFollows,
    DropdownButton
  },
  data() {
    return {
      action: 'follow',
      autoapprove: true,
      domain: ''
    }
  },
  methods: {
    reset() {
      this.domain = ''
    }
  }
}
</script>
